<?php
/** Generated Model Class **/ 

Class Piket {
	private static $columns = "tgl,id_shift,id_poli,id_dokter,id_perawat";
	private static $errors;
	
	private static function generate_date($field_name,$array) {
		if (isset($array[$field_name.'_date']) && isset($array[$field_name.'_month']) && isset($array[$field_name.'_date']))
		$array[$field_name.''] = mktime(0, 0, 0, $array[$field_name.'_month'], $array[$field_name.'_date'], $array[$field_name.'_year']);
		
		return $array;
	}
	
	private static function validate_fields($array) {
		$rules = array();
		$errors = validateFields($array, $rules);
		if (!empty($errors))
		{  
			$error_msg = "<ul>";
			foreach ($errors as $e) { $error_msg .= "<li>{$e}</li>"; }
			$error_msg .= "</ul>";
			Slim::flash('error',$error_msg);
			return false;
		} else { return true; }
	}
	
	public static function create($array) {			
		$piket = R::dispense("piket");
		if (!self::validate_fields($array)) return false;
		
		$piket->import($array,self::$columns);		
		$id = R::store($piket);
		
		return $id;
	}
	
	public static function update($id,$array) {
		$piket = R::load("piket",$id);
		
		if (!self::validate_fields($array)) return false;
		
		$piket->import($array,self::$columns);		
		
		R::store($piket);
		return true;
	}
	
	public static function countAll($search = "") {
		
		return R::getCell("select count(1) from piket");
	}
		
	public static function getAll($page = 1,$count_per_page = 0) {
		$q = "select * from piket";
		$data = R::getAll($q);
		return $data;
	}
	
	public static function generatePage($current_page,$count_per_page,$base_url) {
		$total_page = ceil(self::countAll($where)/$count_per_page);
		for ($i = 1;$i <= $total_page;$i++) {
			$active = ($i == $current_page ? "yes" : "no");
			$page[] = array("number"=>$i,"active"=>$active,"link"=>$base_url."?p=$i");
		}
		return  (isset($page) ? $page : array());
	}
	
	public static function get($id) {
		$data = R::getRow("select * from piket where id = $id");
		return $data;
	}
	
	public static function getByDate($date) {
		$data = R::getAll("SELECT * from piket WHERE tgl = '$date'");
		return $data;
	}
	
	public static function getColumns() {
		return explode(",",self::$columns);
	}

	public static function remove($id) {
		$data = R::load("piket",$id);
		R::trash($data);
	}
	
	public static function removeByTgl($tgl) {
		R::exec("DELETE FROM piket WHERE tgl = '$tgl'");
	}
}
?>
